
import org.codehaus.groovy.grails.commons.ApplicationHolder as AH

class UrlMappings {

  static mappings = {

    // spring security
    "/login/$action?"(controller: "login")
    "/logout/$action?"(controller: "logout")

    // grails default
    "/$controller/$action?/$id?" {
      constraints {
        controller(validator: {
          // accept any controller name that is known to grails and isn't
          // covered by an earlier rule
          it != "browse" &&
            AH.application.getArtefactByLogicalPropertyName('Controller', it)
        })
      }
    }

    // browsing
/* TODO uncomment these if you want to allow browsing multiple FileTrees
    "/browse/$id?/$path**?" {
      controller = "browse"
      action = "index"
      constraints {
        id(validator: { it.matches(/[0-9]+/) })
      }
    }
    "/browse/$path**?" {
      controller = "browse"
      action = "index"
      constraints {
        path(validator: { ! it.matches(/[0-9]+\/.*TODO/) })
      }
    }
*/
    "/"(controller: "browse", action: "index")
    "/$path" {
      controller = "browse"
      action = "index"
      constraints {
        path(validator: {
          path && (! path.startsWith("login")) && (! path.startWith("logout"))
        })
      }
    }

    // top level stuff
    "/admin"(view:"/admin")
    "500"(view:'/error')
    "404"(view:'/error')

  } // mappings

} // UrlMappings
